<template>
  <div class="w-full">
    <div
      v-if="isMobile"
      class="flex items-center time-notice-footer p-2 statement-time-notice"
    >
      <el-icon class="mx-1">
        <clock />
      </el-icon>
      <p>{{ $t("All_transactions_are_time_stamped_at_GMT-4") }}</p>
    </div>
    <div v-if="themeName === 'peru'">
      <el-scrollbar class="hidden-mobile-version">
        <template v-if="transactions.length === 0">
          <lazy-utils-not-found />
        </template>
        <template v-else>
          <div class="flex flex-col gap-2">
            <card-m-bk8-transaction-card
              v-for="transaction in transactions"
              :key="transaction.TransactionNo"
            >
              <template #title>
                <h3 class="text-[14px]" :class="`fc-${transaction.ColorClass}`">
                  {{ $t(transaction.StatusForDisplay) }}
                </h3>
              </template>
              <div class="flex-col flex gap-1">
                <div class="flex justify-between items-center">
                  <p>{{ $t("transaction_no") }}</p>
                  <p class="font-bold">
                    {{ transaction.DisplayTransactionNo }}
                  </p>
                </div>
                <div class="flex justify-between items-center">
                  <p>{{ $t("date") }}</p>
                  <p class="font-bold">
                    {{ transaction.RequestedTimeForDisplay }}
                  </p>
                </div>
                <div class="flex justify-between items-center">
                  <p>{{ $t("request_amount") }}</p>
                  <p class="font-bold fc-success">
                    {{ transaction.RequestedAmountForDisplay }}
                  </p>
                </div>
                <div class="flex justify-between items-center">
                  <p>{{ $t("approved_amount") }}</p>
                  <p
                    :class="`font-bold ${
                      transaction.Status.toLocaleLowerCase() !== 'waiting'
                        ? 'fc-success'
                        : ''
                    }`"
                  >
                    {{ transaction.ApprovedAmountForDisplay }}
                  </p>
                </div>
                <div
                  v-if="transaction.IsCancelable"
                  class="flex justify-end items-center mt-3"
                >
                  <el-button
                    type="plain"
                    :disabled="isProcessing"
                    style="
                      background-color: var(--background-1);
                      --el-border-radius-base: 1rem;
                      border-color: var(--primary);
                      color: var(--primary);
                      font-size: 12px;
                    "
                    @click="cancelTransaction(transaction)"
                    >{{ $t("cancel") }}</el-button
                  >
                </div>
              </div>
            </card-m-bk8-transaction-card>
          </div>
        </template>
      </el-scrollbar>
      <el-scrollbar
        class="hidden-desktop-version"
        :class="{
          'user-center-table-container-max-height': transactions.length === 0,
        }"
      >
        <el-table v-loading="isDataLoading" border :data="transactions">
          <template #empty>
            <lazy-utils-not-found />
          </template>
          <el-table-column
            prop="RequestedTimeForDisplay"
            :label="$t('date')"
            min-width="100"
            align="center"
          />
          <el-table-column
            prop="DisplayTransactionNo"
            :label="$t('transaction_no')"
            min-width="110"
            align="left"
            header-align="center"
          />
          <el-table-column
            prop="RequestedAmountForDisplay"
            :label="$t('requested_amount')"
            align="right"
            header-align="center"
            min-width="100"
          />
          <el-table-column
            :label="$t('approved_amount')"
            header-align="center"
            min-width="100"
          >
            <template #default="scope">
              <span
                :class="`w-full flex ${
                  scope.row.ApprovedAmountForDisplay === '--'
                    ? 'justify-center'
                    : 'justify-end'
                }`"
              >
                {{ scope.row.ApprovedAmountForDisplay }}
              </span>
            </template>
          </el-table-column>
          <el-table-column
            v-if="transactionType === 'DepositHistory'"
            :label="$t('deposit_time')"
            align="center"
            min-width="100"
            prop="DepositTime"
          />
          <el-table-column :label="$t('status')" align="center">
            <template #default="scope">
              <span :class="`fc-${scope.row.ColorClass}`">{{
                $t(String(scope.row.StatusForDisplay))
              }}</span>
            </template>
          </el-table-column>
          <el-table-column :label="$t('action')" align="center">
            <template #default="scope">
              <el-button
                v-if="scope.row.IsCancelable"
                :disabled="isProcessing"
                type="danger"
                plain
                round
                size="small"
                @click="cancelTransaction(scope.row)"
                >{{ $t("cancel") }}</el-button
              >
            </template>
          </el-table-column>
        </el-table>
      </el-scrollbar>
    </div>
    <div v-else>
      <div v-if="isMobile" :class="[{ 'px-2 pb-2 pt-1': !isNoNeedPadding }]">
        <template v-if="transactions.length === 0">
          <lazy-utils-not-found />
        </template>
        <div v-else class="flex flex-col gap-2">
          <card-m-bk8-transaction-card
            v-for="transaction in transactions"
            :key="transaction.TransactionNo"
          >
            <template #title>
              <h3 :class="`fc-${transaction.ColorClass}`">
                {{ $t(transaction.StatusForDisplay) }}
              </h3>
            </template>
            <div class="flex flex-col gap-1">
              <div class="flex justify-between items-center">
                <p>{{ $t("transaction_no") }}</p>
                <p class="font-medium">
                  {{ transaction.DisplayTransactionNo }}
                </p>
              </div>
              <div class="flex justify-between items-center">
                <p>{{ $t("date") }}</p>
                <p class="font-medium">
                  {{ transaction.RequestedTimeForDisplay }}
                </p>
              </div>
              <div class="flex justify-between items-center">
                <p>{{ $t("requested_amount") }}</p>
                <p
                  class="font-medium text-sm"
                  :class="`fc-${transaction.ColorClass}`"
                >
                  {{
                    numberFormatHelper.addAccountingFormat(
                      transaction.RequestedAmount,
                      2,
                      false
                    )
                  }}
                </p>
              </div>
              <div class="flex justify-between items-center">
                <p>{{ $t("approved_amount") }}</p>
                <p
                  class="font-bold text-sm"
                  :class="`fc-${transaction.ColorClass}`"
                >
                  {{ transaction.ApprovedAmountForDisplay }}
                </p>
              </div>
              <div
                v-if="transaction.IsCancelable"
                class="flex justify-end items-center mt-3"
              >
                <CancelButton
                  :disabled="isProcessing"
                  @click="cancelTransaction(transaction)"
                />
              </div>
            </div>
          </card-m-bk8-transaction-card>

          <!-- TODO: Will remove after later -->

          <!-- <el-card
            v-for="data in transactions"
            :key="data"
            shadow="always"
            class="my-5"
          >
            <div class="grid grid-cols-3 gap-2">
              <div>{{ $t("transaction_no") }}</div>
              <div class="col-span-2 text-right">
                {{ data.DisplayTransactionNo }}
              </div>
              <div>{{ $t("date") }}</div>
              <div class="col-span-2 text-right">
                {{ data.RequestedTimeForDisplay }}
              </div>
              <div>{{ $t("requested_amount") }}</div>
              <div class="col-span-2 text-right">
                {{ data.RequestedAmountForDisplay }}
              </div>
              <div>{{ $t("approved_amount") }}</div>
              <div class="col-span-2 text-right">
                {{ data.ApprovedAmountForDisplay }}
              </div>
              <div v-if="transactionType === 'Deposit'">
                {{ $t("deposit_time") }}
              </div>
              <div
                v-if="transactionType === 'Deposit'"
                class="col-span-2 text-right"
              >
                {{ data.DepositTime }}
              </div>
              <div>{{ $t("status") }}</div>
              <div
                class="col-span-2 text-right"
                :class="`fc-${data.ColorClass}`"
              >
                {{ $t(data.StatusForDisplay) }}
              </div>
              <div class="col-span-3 text-right">
                <el-button
                  v-if="data.IsCancelable"
                  :disabled="isProcessing"
                  type="primary"
                  plain
                  round
                  size="small"
                  @click="cancelTransaction(data)"
                  >{{ $t("cancel") }}
                </el-button>
              </div>
            </div>
          </el-card> -->
        </div>
      </div>
      <el-scrollbar v-else>
        <div
          class="rounded-lg"
          :class="{ 'border-table-wrapper': transactions.length }"
        >
          <el-table
            v-loading="isDataLoading"
            border
            :data="transactions"
            height="510"
            class="withdrawal-desktop"
          >
            <template #empty>
              <lazy-utils-not-found />
            </template>
            <el-table-column
              prop="RequestedTimeForDisplay"
              :label="$t('date')"
              min-width="100"
              align="center"
            />
            <el-table-column
              prop="DisplayTransactionNo"
              :label="$t('transaction_no')"
              min-width="110"
              align="left"
              header-align="center"
            />
            <el-table-column
              prop="RequestedAmountForDisplay"
              :label="$t('requested_amount')"
              align="right"
              header-align="center"
            />
            <el-table-column
              :label="$t('approved_amount')"
              header-align="center"
            >
              <template #default="scope">
                <span
                  :class="`w-full flex ${
                    scope.row.ApprovedAmountForDisplay === '--'
                      ? 'justify-center'
                      : 'justify-end'
                  }`"
                >
                  {{ scope.row.ApprovedAmountForDisplay }}
                </span>
              </template>
            </el-table-column>
            <el-table-column
              v-if="transactionType === 'DepositHistory'"
              :label="$t('deposit_time')"
              align="center"
              min-width="100"
              prop="DepositTime"
            />
            <el-table-column :label="$t('status')" align="center">
              <template #default="scope">
                <span :class="`fc-${scope.row.ColorClass}`">{{
                  $t(String(scope.row.StatusForDisplay))
                }}</span>
              </template>
            </el-table-column>
            <el-table-column :label="$t('action')" align="center">
              <template #default="scope">
                <el-button
                  v-if="scope.row.IsCancelable"
                  :disabled="isProcessing"
                  type="danger"
                  plain
                  round
                  size="small"
                  @click="cancelTransaction(scope.row)"
                  >{{ $t("cancel") }}</el-button
                >
              </template>
            </el-table-column>
          </el-table>
        </div>
      </el-scrollbar>
    </div>
    <div v-if="!isMobile" class="flex items-center time-notice-footer mt-4">
      <el-icon class="mx-1">
        <clock />
      </el-icon>
      <p>{{ $t("All_transactions_are_time_stamped_at_GMT-4") }}</p>
    </div>
  </div>
</template>
<script lang="ts" setup>
import { Clock } from "@element-plus/icons-vue";
import CancelButton from "./cancel-button.vue";
import { store } from "~~/store";
import numberFormatHelper from "@/utils/formatHelpers/numberFormatHelper";

const {
  transactions,
  transactionType,
  isDataLoading,
  cancelTransaction,
  isProcessing,
} = useTransactionHistoryMainContent();
const isMobile = !useIsDesktop();
const isNoNeedPadding = computed(
  () =>
    store.state.selectedThemeName === "china" ||
    store.state.selectedThemeName === "modern"
);

const themeColor = computed(() =>
  store.state.companyThemePropertiesFromApi.ThemeProperties.find(
    (t) => t.HtmlId === "theme_color"
  )
);
const isBK8Mobile = computed(
  () =>
    themeColor.value &&
    isMobile &&
    themeColor.value.Text.toLowerCase() === "bk8"
);
const themeName = store.state.selectedThemeName;
</script>
